local *

{
  :GetSendMailItem
  :SendMail
  :SendMailNameEditBox
  :SendMailScrollChildFrame
  :SendMailSubjectEditBox
  :idTweaks
  :idTweaksModule
  :idTweaksOptions
} = _G
{
  :Option
  :ToggleOption
} = idTweaksOptions

-- import reverse from idTweaksUtils.table.map
-- LibSharedMedia = LibStub 'LibSharedMedia-3.0'
-- shared_media_status_bars = LibSharedMedia\HashTable('statusbar')
-- shared_media_status_bars_reversed = reverse shared_media_status_bars
-- shared_media_fonts = LibSharedMedia\HashTable 'font'
-- shared_media_fonts_reversed = reverse shared_media_fonts
-- shared_media_backgrounds = LibSharedMedia\HashTable 'background'
-- shared_media_backgrounds_reversed = reverse shared_media_backgrounds

class Mail extends idTweaksModule
  new: (addon) =>
    super addon, 'Mail', 'AceConsole-3.0', 'AceEvent-3.0'

  set_options: =>
    super!

    @options\add_option ToggleOption @, 'auto_send_mail', 'Auto Send', 'When the mail has a Recipient and all item slots are filled, send it.'

  enable: =>
    @ace_module\RegisterEvent 'MAIL_SEND_INFO_UPDATE', (...) ->
      return unless @db.auto_send_mail
      @send_mail! if @can_send_mail!

  disable: =>
    @ace_module\UnregisterEvent 'MAIL_SEND_INFO_UPDATE'

  get_free_mail_slots: =>
    freeSlots = 0

    for slot = 1, 12
      itemName, _, _, _ = GetSendMailItem slot
      if not itemName
        freeSlots = freeSlots + 1

    freeSlots

  is_mail_full: => @get_free_mail_slots! == 0

  get_mail_recipient: =>
    SendMailNameEditBox\GetText!

  set_mail_recipient: (recipient) =>
    SendMailNameEditBox\SetText recipient

  mail_has_recipient: =>
    @get_mail_recipient! ~= ''

  get_mail_subject: =>
    SendMailSubjectEditBox\GetText!

  mail_has_subject: =>
    @get_mail_subject! ~= ''

  get_mail_body: =>
    SendMailScrollChildFrame\GetText!

  can_send_mail: =>
    @mail_has_recipient! and @mail_has_subject! and @is_mail_full!

  send_mail: =>
    recipient = @get_mail_recipient!
    subject = @get_mail_subject!
     -- body = @get_mail_body!

    SendMail recipient, subject, ''

    @set_mail_recipient recipient

idTweaks\add_module Mail idTweaks
